FixMacRecording = LibStub("AceAddon-3.0"):NewAddon("FixMacRecording", "AceEvent-3.0", "AceConsole-3.0")

local AceConfigDialog = LibStub("AceConfigDialog-3.0")

FixMacRecording.reload = 0

local defaults = {
	profile = {
		SHADOWS = 4,
	}
}

local options = {
	name = "FixMacRecording",
	handler = FixMacRecording,
	type = 'group',
	args = {
		SHADOWS = {
			type = "select",
			name = "Shadow Quality",
			desc = "Shadow Quality to use while playing. This setting takes effect upon next login and will overwrite anything set in Graphics options.",
			get = function() return FixMacRecording.db.profile.SHADOWS end,
			set = function(info, v)
					FixMacRecording.db.profile.SHADOWS = v
				end,
			values = {"Low", "Fair", "Good", "High", "Ultra"},
			order = 1,
		},
	},
}

function FixMacRecording:slashies()
	if not command or command:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
	else
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
	end
end

function FixMacRecording:OnInitialize()
--	self:Print("FixMacRecording initialized.")
	self.db = LibStub("AceDB-3.0"):New("FixMacRecordingDB", defaults)
	self:RegisterChatCommand("FixMacRecording", "slashies")
	self:RegisterChatCommand("fmr", "slashies")
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("FixMacRecording", "FixMacRecording")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("FixMacRecording", options)
	self:RegisterEvent("PLAYER_LOGOUT", "badShadows")
	self:RegisterEvent("PLAYER_LOGIN", "goodShadows")
end

function FixMacRecording:OnEnable()
end

function FixMacRecording:OnDisable()
end

function FixMacRecording:badShadows()
--	self:Print("badshadows")
	SetCVar("shadowMode", 1)
end

function FixMacRecording:goodShadows()
--	self:Print("goodshadows")
--	self:Print(self.db.profile.SHADOWS)
	if self.db.profile.SHADOWS == 5 then -- Ultra
		SetCVar("shadowMode", 3)
		SetCVar("shadowTextureSize", 2048)
	elseif self.db.profile.SHADOWS == 4 then -- High
		SetCVar("shadowMode", 2)
		SetCVar("shadowTextureSize", 2048)
	elseif self.db.profile.SHADOWS == 3 then -- Good
		SetCVar("shadowMode", 1)
		SetCVar("shadowTextureSize", 2048)
	elseif self.db.profile.SHADOWS == 2 then -- Fair
		SetCVar("shadowMode", 1)
		SetCVar("shadowTextureSize", 1024)
	elseif self.db.profile.SHADOWS == 1 then -- Low
		SetCVar("shadowMode", 0)
	end
	if (self.reload == 0) then
		RestartGx()
		self.reload = 1
	end
end